package hk.quantr.netbeans.vcd;

import java.io.File;
import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.openide.filesystems.FileObject;
import org.openide.util.Lookup;
import org.openide.util.NbBundle.Messages;
import org.openide.windows.TopComponent;

@MultiViewElement.Registration(
		displayName = "#LBL_VCD_WAVEFORM",
		iconBase = "hk/quantr/netbeans/vcd/vcd.png",
		mimeType = "text/quantr+vcd",
		persistenceType = TopComponent.PERSISTENCE_NEVER,
		preferredID = "VCDWaveform",
		position = 2000
)
@Messages("LBL_VCD_WAVEFORM=Waveform")
public final class VCDWaveformElement extends JPanel implements MultiViewElement {

	private VCDDataObject obj;
	private JToolBar toolbar = new JToolBar();
	private transient MultiViewElementCallback callback;

	public VCDWaveformElement(Lookup lkp) {
		obj = lkp.lookup(VCDDataObject.class);
		assert obj != null;
		initComponents();
		initVCD();
	}

	@Override
	public String getName() {
		return "VCDWaveformElement";
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        quantrVCDComponent = new hk.quantr.vcdcomponent.QuantrVCDComponent();

        setLayout(new java.awt.BorderLayout());
        add(quantrVCDComponent, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private hk.quantr.vcdcomponent.QuantrVCDComponent quantrVCDComponent;
    // End of variables declaration//GEN-END:variables
	@Override
	public JComponent getVisualRepresentation() {
		return this;
	}

	@Override
	public JComponent getToolbarRepresentation() {
		return toolbar;
	}

	@Override
	public Action[] getActions() {
		return new Action[0];
	}

	@Override
	public Lookup getLookup() {
		return obj.getLookup();
	}

	@Override
	public void componentOpened() {
	}

	@Override
	public void componentClosed() {
	}

	@Override
	public void componentShowing() {
	}

	@Override
	public void componentHidden() {
	}

	@Override
	public void componentActivated() {
	}

	@Override
	public void componentDeactivated() {
	}

	@Override
	public UndoRedo getUndoRedo() {
		return UndoRedo.NONE;
	}

	@Override
	public void setMultiViewCallback(MultiViewElementCallback callback) {
		this.callback = callback;
	}

	@Override
	public CloseOperationState canCloseElement() {
		return CloseOperationState.STATE_OK;
	}

	private void initVCD() {
		try {
			FileObject f = obj.getPrimaryFile();
			quantrVCDComponent.loadVCD(new File(f.getPath()));
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

}
